;-----tasm /m example
;-----tlink example

                MODEL   Small
                STACK   256

                DATASEG

videomode       db      3h       
inFile          dw      0
inFile2         dw      0
file            db      'sample.dat',0
file2           db      'sample.pal',0
buff            db      64001   DUP     (?)
pal             db      769     DUP     (?)

                CODESEG


Start:
        mov     ax, @data               ; initialize seg regs
        mov     ds, ax
        mov     es, ax

        mov     ah, 0Fh                 ; save current video mode
        int     10h
        mov     [videomode], al


        mov     ah, 3Dh                 ; open picture file
        mov     al, 0
        mov     dx, offset file
        int     21h
        jc      Exit
        mov     [inFile], ax

        mov     ah, 3Dh                 ; open palette file
        mov     al, 0
        mov     dx, offset file2
        int     21h
        jc      Exit
        mov     [inFile2], ax


        mov     ah, 3Fh                 ; load picture file into buffer
        mov     bx, [inFile]
        mov     cx, 64000
        mov     dx, offset buff
        int     21h
        jc      Exit

        mov     ah, 3Fh                 ; load palette file into buffer
        mov     bx, [inFile2]
        mov     cx, 768
        mov     dx, offset pal
        int     21h
        jc      Exit

                                        ; set graphics mode
        mov     ah, 0
        mov     al, 13h
        int     10h

        mov     ah, 10h                 ; set palette registers
        mov     al, 12h
        mov     bx, 0
        mov     cx, 256
        mov     dx, offset pal
        int     10h


        mov     si, offset buff         ; show it
        mov     ax, 0A000h
        mov     es, ax
        xor     di, di
        mov     cx, 64000
        rep     movsb
                                        ; hold it
        xor     ah, ah
        int     16h
Exit:
        mov     ah, 0                   ; reset the mode
        mov     al, [videomode]
        int     10h

        mov     ah, 4Ch                 ; home to Mother DOS
        xor     al, al
        int     21h

                END     Start
